package dev.shadowsoffire.apotheosis.ench.library;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import dev.shadowsoffire.apotheosis.ench.library.EnchLibraryTile;
import dev.shadowsoffire.placebo.menu.MenuUtil;
import dev.shadowsoffire.placebo.menu.SimplerMenuProvider;
import java.util.Arrays;
import java.util.List;
import net.minecraft.ChatFormatting;
import net.minecraft.core.BlockPos;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.nbt.Tag;
import net.minecraft.network.chat.Component;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.InteractionResult;
import net.minecraft.world.MenuProvider;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.TooltipFlag;
import net.minecraft.world.item.context.BlockPlaceContext;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.EntityBlock;
import net.minecraft.world.level.block.HorizontalDirectionalBlock;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.level.block.state.properties.Property;
import net.minecraft.world.level.material.MapColor;
import net.minecraft.world.level.storage.loot.LootParams;
import net.minecraft.world.level.storage.loot.parameters.LootContextParams;
import net.minecraft.world.phys.BlockHitResult;
import net.minecraft.world.phys.HitResult;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.api.distmarker.OnlyIn;

public class EnchLibraryBlock extends HorizontalDirectionalBlock implements EntityBlock {
  public static final Component NAME = (Component)Component.m_237115_("apotheosis.ench.library");
  
  protected final BlockEntityType.BlockEntitySupplier<? extends EnchLibraryTile> tileSupplier;
  
  protected final int maxLevel;
  
  public EnchLibraryBlock(BlockEntityType.BlockEntitySupplier<? extends EnchLibraryTile> tileSupplier, int maxLevel) {
    super(BlockBehaviour.Properties.m_284310_().m_284180_(MapColor.f_283913_).m_60913_(5.0F, 1200.0F));
    this.tileSupplier = tileSupplier;
    this.maxLevel = maxLevel;
  }
  
  public InteractionResult m_6227_(BlockState state, Level world, BlockPos pos, Player player, InteractionHand handIn, BlockHitResult hit) {
    return MenuUtil.openGui(player, pos, dev.shadowsoffire.apotheosis.ench.library.EnchLibraryContainer::new);
  }
  
  public MenuProvider m_7246_(BlockState state, Level world, BlockPos pos) {
    return (MenuProvider)new SimplerMenuProvider(world, pos, dev.shadowsoffire.apotheosis.ench.library.EnchLibraryContainer::new);
  }
  
  protected void m_7926_(StateDefinition.Builder<Block, BlockState> builder) {
    builder.m_61104_(new Property[] { (Property)f_54117_ });
  }
  
  public BlockState m_5573_(BlockPlaceContext p_196258_1_) {
    return (BlockState)m_49966_().m_61124_((Property)f_54117_, (Comparable)p_196258_1_.m_8125_().m_122424_());
  }
  
  public BlockEntity m_142194_(BlockPos pPos, BlockState pState) {
    return this.tileSupplier.m_155267_(pPos, pState);
  }
  
  public ItemStack getCloneItemStack(BlockState state, HitResult target, BlockGetter world, BlockPos pos, Player player) {
    ItemStack s = new ItemStack((ItemLike)this);
    BlockEntity te = world.m_7702_(pos);
    if (te != null)
      s.m_41784_().m_128365_("BlockEntityTag", (Tag)te.m_187482_()); 
    return s;
  }
  
  public void m_6402_(Level world, BlockPos pos, BlockState state, LivingEntity placer, ItemStack stack) {
    BlockEntity te = world.m_7702_(pos);
    if (te != null)
      te.m_142466_(stack.m_41698_("BlockEntityTag")); 
  }
  
  public List<ItemStack> m_49635_(BlockState state, LootParams.Builder ctx) {
    ItemStack s = new ItemStack((ItemLike)this);
    BlockEntity te = (BlockEntity)ctx.m_287261_(LootContextParams.f_81462_);
    if (te != null)
      s.m_41784_().m_128365_("BlockEntityTag", (Tag)te.m_187482_()); 
    return Arrays.asList(new ItemStack[] { s });
  }
  
  @OnlyIn(Dist.CLIENT)
  public void m_5871_(ItemStack stack, BlockGetter world, List<Component> list, TooltipFlag advanced) {
    list.add(Component.m_237110_("tooltip.enchlib.capacity", new Object[] { Component.m_237115_("enchantment.level." + this.maxLevel) }).m_130940_(ChatFormatting.GOLD));
    CompoundTag tag = stack.m_41737_("BlockEntityTag");
    if (tag != null && tag.m_128441_("Points"))
      list.add(Component.m_237110_("tooltip.enchlib.item", new Object[] { Integer.valueOf(tag.m_128469_("Points").m_128440_()) }).m_130940_(ChatFormatting.GOLD)); 
  }
  
  public void m_6810_(BlockState state, Level world, BlockPos pos, BlockState newState, boolean isMoving) {
    if (newState.m_60734_() != this)
      world.m_46747_(pos); 
  }
}
